Project Groups

Get a paginated list of the Project Groups in the supplied Octopus Deploy Space. The results will be sorted alphabetically by name

GET /api/{spaceId}/projectgroups

Also reachable at /api/projectgroups, /api/spaces/{spaceIdentifier}/projectgroups.

Path Parameters

  • spaceId string (required)
    The ID of the space containing the resource(s).

Query Parameters

  • ids array of string
    A comma separated list of Project Group IDs to filter on.
  • name string
    The exact name of a Project Group to be matched.
  • partialName string
    A partial or complete name to limit the set of retrieved Project Groups to. This will perform a “contains” style match against the supplied name or name-fragment.
  • skip integer
    Number of items to skip. Defaults to zero. Minimum 0.
  • take integer
    Number of items to take. Defaults to 30. Minimum 0.

Response

200 — A paginated list of the Project Groups in the supplied Octopus Deploy Space. The results will be sorted alphabetically by name.

  • Id string
    Gets or sets a unique identifier for this resource.
  • ItemType string
  • Items array of object
    • Description string
    • EnvironmentIds array of string
      Gets or sets a collection of environment ID’s. If this collection is empty, projects in this group can be deployed to any environment. If the collection is non-empty, then projects in the group are limited to only deploying to the environments listed in this collection. Obsolete. Environments are now controlled by lifecycles as of Oct 2014, version 2.6.5.
    • Id string
      Gets or sets a unique identifier for this resource.
    • LastModifiedBy string
      Gets or sets the username of the user who last modified this resource.
    • LastModifiedOn string
      Gets or sets the date/time that this resource was last modified. Format date-time.
    • Links object
      Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.
    • Name string
      Gets or sets the name of this project group.
    • RetentionPolicyId string
      Gets or sets the ID of the retention policy that will apply to projects in this group.
    • Slug string
    • SpaceId string
  • ItemsPerPage integer
  • LastModifiedBy string
    Gets or sets the username of the user who last modified this resource.
  • LastModifiedOn string
    Gets or sets the date/time that this resource was last modified. Format date-time.
  • LastPageNumber integer
  • Links object
    Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.
  • NumberOfPages integer
  • TotalResults integer

Example Response

JSON
{
  "Id": "string",
  "ItemType": "string",
  "Items": [
    {
      "Description": "string",
      "EnvironmentIds": [
        "string"
      ],
      "Id": "string",
      "LastModifiedBy": "string",
      "LastModifiedOn": "2020-01-01T00:00:00.000Z",
      "Links": {
        "additionalProp1": "string",
        "additionalProp2": "string",
        "additionalProp3": "string"
      },
      "Name": "string",
      "RetentionPolicyId": "string",
      "Slug": "string",
      "SpaceId": "string"
    }
  ],
  "ItemsPerPage": 0,
  "LastModifiedBy": "string",
  "LastModifiedOn": "2020-01-01T00:00:00.000Z",
  "LastPageNumber": 0,
  "Links": {
    "additionalProp1": "string",
    "additionalProp2": "string",
    "additionalProp3": "string"
  },
  "NumberOfPages": 0,
  "TotalResults": 0
}

Create a new project group

POST /api/{spaceId}/projectgroups

Also reachable at /api/projectgroups, /api/spaces/{spaceIdentifier}/projectgroups.

Path Parameters

  • spaceId string (required)
    The ID of the space containing the resource(s).

Request Body

  • Description string
    The description of the project group.
  • Name string (required)
    The name of the project group. Minimum length 1.
  • Slug string
  • SpaceId string (required)
    The ID of the space containing the resource(s).

Response

201 — Created

  • Description string
  • EnvironmentIds array of string
    Gets or sets a collection of environment ID’s. If this collection is empty, projects in this group can be deployed to any environment. If the collection is non-empty, then projects in the group are limited to only deploying to the environments listed in this collection. Obsolete. Environments are now controlled by lifecycles as of Oct 2014, version 2.6.5.
  • Id string
    Gets or sets a unique identifier for this resource.
  • LastModifiedBy string
    Gets or sets the username of the user who last modified this resource.
  • LastModifiedOn string
    Gets or sets the date/time that this resource was last modified. Format date-time.
  • Links object
    Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.
  • Name string
    Gets or sets the name of this project group.
  • RetentionPolicyId string
    Gets or sets the ID of the retention policy that will apply to projects in this group.
  • Slug string
  • SpaceId string

Example Request

JSON
{
  "Description": "string",
  "Name": "string",
  "Slug": "string",
  "SpaceId": "string"
}

Example Response

JSON
{
  "Description": "string",
  "EnvironmentIds": [
    "string"
  ],
  "Id": "string",
  "LastModifiedBy": "string",
  "LastModifiedOn": "2020-01-01T00:00:00.000Z",
  "Links": {
    "additionalProp1": "string",
    "additionalProp2": "string",
    "additionalProp3": "string"
  },
  "Name": "string",
  "RetentionPolicyId": "string",
  "Slug": "string",
  "SpaceId": "string"
}

List the name and ID of all of the Project Groups in the supplied Octopus Deploy Space. The results will be sorted alphabetically by name

GET /api/{spaceId}/projectgroups/all

Also reachable at /api/projectgroups/all, /api/spaces/{spaceIdentifier}/projectgroups/all.

Path Parameters

  • spaceId string (required)

Response

200 — The name and ID of all of the Project Groups in the supplied Octopus Deploy Space. The results are sorted alphabetically by name.“

  • Description string
  • EnvironmentIds array of string
    Gets or sets a collection of environment ID’s. If this collection is empty, projects in this group can be deployed to any environment. If the collection is non-empty, then projects in the group are limited to only deploying to the environments listed in this collection. Obsolete. Environments are now controlled by lifecycles as of Oct 2014, version 2.6.5.
  • Id string
    Gets or sets a unique identifier for this resource.
  • LastModifiedBy string
    Gets or sets the username of the user who last modified this resource.
  • LastModifiedOn string
    Gets or sets the date/time that this resource was last modified. Format date-time.
  • Links object
    Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.
  • Name string
    Gets or sets the name of this project group.
  • RetentionPolicyId string
    Gets or sets the ID of the retention policy that will apply to projects in this group.
  • Slug string
  • SpaceId string

Example Response

JSON
[
  {
    "Description": "string",
    "EnvironmentIds": [
      "string"
    ],
    "Id": "string",
    "LastModifiedBy": "string",
    "LastModifiedOn": "2020-01-01T00:00:00.000Z",
    "Links": {
      "additionalProp1": "string",
      "additionalProp2": "string",
      "additionalProp3": "string"
    },
    "Name": "string",
    "RetentionPolicyId": "string",
    "Slug": "string",
    "SpaceId": "string"
  }
]

Get a Project Group by ID

GET /api/{spaceId}/projectgroups/{id}

Also reachable at /api/projectgroups/{id}, /api/spaces/{spaceIdentifier}/projectgroups/{id}.

Path Parameters

  • id string (required)
    ID of the ProjectGroup to load.
  • spaceId string (required)
    The ID of the space containing the resource(s).

Response

200 — The requested project group

  • Description string
  • EnvironmentIds array of string
    Gets or sets a collection of environment ID’s. If this collection is empty, projects in this group can be deployed to any environment. If the collection is non-empty, then projects in the group are limited to only deploying to the environments listed in this collection. Obsolete. Environments are now controlled by lifecycles as of Oct 2014, version 2.6.5.
  • Id string
    Gets or sets a unique identifier for this resource.
  • LastModifiedBy string
    Gets or sets the username of the user who last modified this resource.
  • LastModifiedOn string
    Gets or sets the date/time that this resource was last modified. Format date-time.
  • Links object
    Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.
  • Name string
    Gets or sets the name of this project group.
  • RetentionPolicyId string
    Gets or sets the ID of the retention policy that will apply to projects in this group.
  • Slug string
  • SpaceId string

Example Response

JSON
{
  "Description": "string",
  "EnvironmentIds": [
    "string"
  ],
  "Id": "string",
  "LastModifiedBy": "string",
  "LastModifiedOn": "2020-01-01T00:00:00.000Z",
  "Links": {
    "additionalProp1": "string",
    "additionalProp2": "string",
    "additionalProp3": "string"
  },
  "Name": "string",
  "RetentionPolicyId": "string",
  "Slug": "string",
  "SpaceId": "string"
}

Modify an existing project group

PUT /api/{spaceId}/projectgroups/{id}

Also reachable at /api/projectgroups/{id}, /api/spaces/{spaceIdentifier}/projectgroups/{id}.

Path Parameters

  • id string (required)
    The ID of the project group.
  • spaceId string (required)
    The ID of the space containing the resource(s).

Request Body

  • Description string
    The description of the project group.
  • Id string (required)
    The ID of the project group.
  • Name string (required)
    The name of the project group. Minimum length 1.
  • Slug string
  • SpaceId string (required)
    The ID of the space containing the resource(s).

Response

200 — The modified project group

  • Description string
  • EnvironmentIds array of string
    Gets or sets a collection of environment ID’s. If this collection is empty, projects in this group can be deployed to any environment. If the collection is non-empty, then projects in the group are limited to only deploying to the environments listed in this collection. Obsolete. Environments are now controlled by lifecycles as of Oct 2014, version 2.6.5.
  • Id string
    Gets or sets a unique identifier for this resource.
  • LastModifiedBy string
    Gets or sets the username of the user who last modified this resource.
  • LastModifiedOn string
    Gets or sets the date/time that this resource was last modified. Format date-time.
  • Links object
    Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.
  • Name string
    Gets or sets the name of this project group.
  • RetentionPolicyId string
    Gets or sets the ID of the retention policy that will apply to projects in this group.
  • Slug string
  • SpaceId string

Example Request

JSON
{
  "Description": "string",
  "Id": "string",
  "Name": "string",
  "Slug": "string",
  "SpaceId": "string"
}

Example Response

JSON
{
  "Description": "string",
  "EnvironmentIds": [
    "string"
  ],
  "Id": "string",
  "LastModifiedBy": "string",
  "LastModifiedOn": "2020-01-01T00:00:00.000Z",
  "Links": {
    "additionalProp1": "string",
    "additionalProp2": "string",
    "additionalProp3": "string"
  },
  "Name": "string",
  "RetentionPolicyId": "string",
  "Slug": "string",
  "SpaceId": "string"
}

Delete an existing Project Group

DELETE /api/{spaceId}/projectgroups/{id}

Also reachable at /api/projectgroups/{id}, /api/spaces/{spaceIdentifier}/projectgroups/{id}.

Path Parameters

  • id string (required)
    The ID of the project group to delete.
  • spaceId string (required)
    The ID of the space containing the resource(s).

Response

200 — Success

Get a paginated list of the Projects that belong to the given Project Group

GET /api/{spaceId}/projectgroups/{id}/projects

Also reachable at /api/projectgroups/{id}/projects, /api/spaces/{spaceIdentifier}/projectgroups/{id}/projects.

Path Parameters

  • id string (required)
    The ID of the project group.
  • spaceId string (required)
    The ID of the space containing the resource(s).

Query Parameters

  • skip integer
    Number of items to skip. Defaults to zero. Minimum 0.
  • take integer
    Number of items to take. Defaults to 30. Minimum 0.

Response

200 — A paginated list of the Projects that belong to the given Project Group

  • Id string
    Gets or sets a unique identifier for this resource.
  • ItemType string
  • Items array of object
    • AllowIgnoreChannelRules boolean
    • AutoCreateRelease boolean
    • AutoDeployReleaseOverrides array of object
    • ClonedFromProjectId string
    • CombineHealthAndSyncStatusInDashboardLiveStatus boolean
    • DefaultGuidedFailureMode enum
      Allowed values: EnvironmentDefault, Off, On.
    • DefaultPowerShellEdition string
    • DefaultToSkipIfAlreadyInstalled boolean
    • DeploymentChangesTemplate string
    • DeploymentProcessId string
    • DeprovisioningRunbookId string
    • Description string
    • DiscreteChannelRelease boolean
      Treats releases of different channels to the same environment as a seperate deployment dimension. ‘False’ indicates a “hotfix”-style usage of channels (single release active per environment ignoring channels), whereas True indicates “microservice”-style usage (single release per environment per channel).
    • ExecuteDeploymentsOnEventBasedPipeline boolean
    • ExtensionSettings array of object
    • ForcePackageDownload boolean
    • Icon object
    • Id string
      Gets or sets a unique identifier for this resource.
    • IncludedLibraryVariableSetIds array of string
      Library variable sets included in the project. Sets are listed in order of precedence, with earlier items in the list overriding any variables with the same name and scope definition appearing later in the list.
    • IsBadgesEnabled boolean
    • IsDisabled boolean
    • IsVersionControlled boolean
    • LastModifiedBy string
      Gets or sets the username of the user who last modified this resource.
    • LastModifiedOn string
      Gets or sets the date/time that this resource was last modified. Format date-time.
    • LifecycleId string
    • Links object
      Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.
    • Name string
    • PersistenceSettings object
    • ProjectConnectivityPolicy object
    • ProjectGroupId string
    • ProjectTags array of string
      List of tags assigned to this project.
    • ProjectTemplateDetails object
    • ProvisioningRunbookId string
    • ReleaseCreationStrategy object
    • ReleaseNotesTemplate string
    • Slug string
    • SpaceId string
    • Templates array of object
    • TenantedDeploymentMode enum
      Allowed values: Untenanted, TenantedOrUntenanted, Tenanted.
    • VariableSetId string
    • VersioningStrategy object
  • ItemsPerPage integer
  • LastModifiedBy string
    Gets or sets the username of the user who last modified this resource.
  • LastModifiedOn string
    Gets or sets the date/time that this resource was last modified. Format date-time.
  • LastPageNumber integer
  • Links object
    Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.
  • NumberOfPages integer
  • TotalResults integer

Example Response

JSON
{
  "Id": "string",
  "ItemType": "string",
  "Items": [
    {
      "AllowIgnoreChannelRules": true,
      "AutoCreateRelease": true,
      "AutoDeployReleaseOverrides": [
        {}
      ],
      "ClonedFromProjectId": "string",
      "CombineHealthAndSyncStatusInDashboardLiveStatus": true,
      "DefaultGuidedFailureMode": "EnvironmentDefault",
      "DefaultPowerShellEdition": "string",
      "DefaultToSkipIfAlreadyInstalled": true,
      "DeploymentChangesTemplate": "string",
      "DeploymentProcessId": "string",
      "DeprovisioningRunbookId": "string",
      "Description": "string",
      "DiscreteChannelRelease": true,
      "ExecuteDeploymentsOnEventBasedPipeline": true,
      "ExtensionSettings": [
        {}
      ],
      "ForcePackageDownload": true,
      "Icon": {
        "Color": "string",
        "Id": "string"
      },
      "Id": "string",
      "IncludedLibraryVariableSetIds": [
        "string"
      ],
      "IsBadgesEnabled": true,
      "IsDisabled": true,
      "IsVersionControlled": true,
      "LastModifiedBy": "string",
      "LastModifiedOn": "2020-01-01T00:00:00.000Z",
      "LifecycleId": "string",
      "Links": {
        "additionalProp1": "string",
        "additionalProp2": "string",
        "additionalProp3": "string"
      },
      "Name": "string",
      "PersistenceSettings": {
        "Type": "Database"
      },
      "ProjectConnectivityPolicy": {
        "AllowDeploymentsToNoTargets": true,
        "ExcludeUnhealthyTargets": true,
        "SkipMachineBehavior": "None",
        "TargetRoles": [
          "string"
        ]
      },
      "ProjectGroupId": "string",
      "ProjectTags": [
        "string"
      ],
      "ProjectTemplateDetails": {
        "IsShared": true,
        "Slug": "string",
        "VersionMask": "string"
      },
      "ProvisioningRunbookId": "string",
      "ReleaseCreationStrategy": {
        "ChannelId": "string",
        "ReleaseCreationPackage": {}
      },
      "ReleaseNotesTemplate": "string",
      "Slug": "string",
      "SpaceId": "string",
      "Templates": [
        {}
      ],
      "TenantedDeploymentMode": "Untenanted",
      "VariableSetId": "string",
      "VersioningStrategy": {
        "DonorPackage": {},
        "Template": "string"
      }
    }
  ],
  "ItemsPerPage": 0,
  "LastModifiedBy": "string",
  "LastModifiedOn": "2020-01-01T00:00:00.000Z",
  "LastPageNumber": 0,
  "Links": {
    "additionalProp1": "string",
    "additionalProp2": "string",
    "additionalProp3": "string"
  },
  "NumberOfPages": 0,
  "TotalResults": 0
}